DEF VAR cFileName      AS CHAR   NO-UNDO.
DEF VAR cLine          AS CHAR   NO-UNDO.
DEF VAR lRead          AS LOG    NO-UNDO INIT TRUE.
DEF VAR iRecords       AS INT    NO-UNDO.
DEF VAR sp-companycode AS CHAR   NO-UNDO.
DEF VAR cSep           AS CHAR   NO-UNDO.
DEF VAR hBuffer        AS HANDLE NO-UNDO.
DEF VAR hField         AS HANDLE NO-UNDO.
DEF VAR iLoop          AS INT    NO-UNDO.
DEF VAR cValue         AS CHAR   NO-UNDO.
DEF VAR cField         AS CHAR   NO-UNDO.
DEF VAR cHeader        AS CHAR   NO-UNDO.
DEF VAR iEntry         AS INT    NO-UNDO.
DEF VAR iVessel        AS INT    NO-UNDO.

cSep           = CHR(9).
sp-companycode = "ROW".
cFileName      = "C:\Documents and Settings\jetse\Desktop\vessels-dummy.txt".

INPUT FROM VALUE( cFilename ).
  
DO WHILE lRead:
  RUN readLine (OUTPUT cLine
                 ,OUTPUT lRead).
  IF lRead
  THEN DO:
    IF cHeader = "" THEN cHeader = cLine. 
    ELSE DO TRANSACTION ON ERROR UNDO,LEAVE:
      
      iEntry = LOOKUP('vesselnr',cHeader,cSep).
      iVessel = int(ENTRY(iEntry,cLine,cSep)).
      FIND aa-vessel WHERE
           aa-vessel.companycode = sp-companycode
       AND aa-vessel.vesselnr    = iVessel
           EXCLUSIVE NO-ERROR.
      IF NOT AVAIL aa-vessel 
      THEN DO:
        CREATE aa-vessel.
        ASSIGN aa-vessel.companycode = sp-companycode.
      END.
      hBuffer = BUFFER aa-vessel:HANDLE.
      
      DO iLoop = 1 TO NUM-ENTRIES(cHeader,cSep):
        cField = ENTRY(iLoop,cHeader,cSep).
        cValue = ENTRY(iLoop,cLine,cSep).
        hField = hBuffer:BUFFER-FIELD(cField).
        IF cValue <> "" 
        THEN CASE hField:DATA-TYPE:
          WHEN 'DATE'     THEN hField:BUFFER-VALUE = DATE(cValue).
          WHEN 'INTEGER'  THEN hField:BUFFER-VALUE = INT(cValue).
          WHEN 'DECIMAL'  THEN hField:BUFFER-VALUE = DEC(cValue).
          WHEN 'LOGICAL'  THEN hField:BUFFER-VALUE = (IF cValue = "yes" 
                                                      THEN TRUE ELSE FALSE).
          OTHERWISE hField:BUFFER-VALUE = cValue.
        END.
      END.
      iRecords = iRecords + 1.
    END.
  END.
END.

INPUT CLOSE.

MESSAGE iRecords.

PROCEDURE readLine:
  DEF OUTPUT PARAMETER pcLine AS CHAR NO-UNDO.
  DEF OUTPUT PARAMETER plOk   AS LOG  NO-UNDO INIT FALSE.

  IMPORT UNFORMATTED pcLine.
  
  ASSIGN plOk = TRUE.    

END PROCEDURE.


