DEF VAR cFileName      AS CHAR   NO-UNDO.
DEF VAR cLine          AS CHAR   NO-UNDO.
DEF VAR lRead          AS LOG    NO-UNDO INIT TRUE.
DEF VAR iRecords       AS INT    NO-UNDO.
DEF VAR iErrors        AS INT    NO-UNDO.
DEF VAR sp-companycode AS CHAR   NO-UNDO.
DEF VAR cSep           AS CHAR   NO-UNDO.
DEF VAR hBuffer        AS HANDLE NO-UNDO.
DEF VAR hField         AS HANDLE NO-UNDO.
DEF VAR iLoop          AS INT    NO-UNDO.
DEF VAR cValue         AS CHAR   NO-UNDO.
DEF VAR cField         AS CHAR   NO-UNDO.
DEF VAR cHeader        AS CHAR   NO-UNDO.
DEF VAR iEntry         AS INT    NO-UNDO.
DEF VAR cPrefix        AS CHAR   NO-UNDO.
DEF VAR cNumber        AS CHAR   NO-UNDO.

DEF BUFFER b-ec-container FOR ec-container.

cSep           = CHR(9).
sp-companycode = "ROW".
cFileName      = "C:\edi\eucon\mc\Extra_containerdetails.txt".
INPUT FROM VALUE( cFilename ).

OUTPUT TO VALUE(SESSION:TEMP-DIR + "update-container-log.txt").
  
DO WHILE lRead:
  RUN readLine (OUTPUT cLine
                 ,OUTPUT lRead).
  IF lRead
  THEN DO:
    IF cHeader = "" THEN cHeader = cLine. 
    ELSE DO TRANSACTION ON ERROR UNDO,LEAVE:
      
      iEntry  = LOOKUP('containerprefix',cHeader,cSep).
      cPrefix = ENTRY(iEntry,cLine,cSep).
      iEntry  = LOOKUP('containernr',cHeader,cSep).
      cNumber = ENTRY(iEntry,cLine,cSep).
      
      FIND b-ec-container WHERE
           b-ec-container.companycode     = sp-companycode
       AND b-ec-container.containerprefix = cPrefix
       AND b-ec-container.containernr     = cNumber
           EXCLUSIVE NO-ERROR.
      IF NOT AVAIL b-ec-container 
      THEN DO:
        PUT UNFORMATTED cPrefix cNumber " not found." SKIP.
        iErrors = iErrors + 1.
      END.
      ELSE DO:
        hBuffer = BUFFER b-ec-container:HANDLE.
        
        FIELDS-LOOP:
        DO iLoop = 1 TO NUM-ENTRIES(cHeader,cSep):
          cField = ENTRY(iLoop,cHeader,cSep).
          IF LOOKUP(cField,"containerprefix,containernr") > 0
          THEN NEXT FIELDS-LOOP.
          cValue = ENTRY(iLoop,cLine,cSep).
          hField = hBuffer:BUFFER-FIELD(cField).
          IF cValue <> "" 
          THEN CASE hField:DATA-TYPE:
            WHEN 'DATE'     THEN hField:BUFFER-VALUE = DATE(cValue).
            WHEN 'INTEGER'  THEN hField:BUFFER-VALUE = INT(cValue).
            WHEN 'DECIMAL'  THEN hField:BUFFER-VALUE = DEC(cValue).
            WHEN 'LOGICAL'  THEN hField:BUFFER-VALUE = (IF cValue = "yes" 
                                                        THEN TRUE ELSE FALSE).
            OTHERWISE hField:BUFFER-VALUE = cValue.
          END.
        END.
        iRecords = iRecords + 1.
      END.
    END.
  END.
END.

INPUT CLOSE.

PUT UNFORMATTED "Updated:" iRecords SKIP
                "Errors :" iErrors  SKIP
                .
OUTPUT CLOSE.

MESSAGE "Updated:" iRecords SKIP(1) 
        "Errors:" iErrors   SKIP
        "Error log file:" SESSION:TEMP-DIR + "update-container-log.txt"
          .

PROCEDURE readLine:
  DEF OUTPUT PARAMETER pcLine AS CHAR NO-UNDO.
  DEF OUTPUT PARAMETER plOk   AS LOG  NO-UNDO INIT FALSE.

  IMPORT UNFORMATTED pcLine.
  
  ASSIGN plOk = TRUE.    

END PROCEDURE.


